<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset='utf-8'>
  <title>Task 43</title>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Popper Development version -->
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- Import DataTable Library -->

</head>

<body>
  <div>
    <div class="mt-5">
      <div class="text-center">
        <h3>DANH SÁCH ĐƠN HÀNG</h3>
        <div class="container jumbotron">
          <div class="row">
            <div class="col-md-2">
              <label>Trạng thái order</label>
            </div>
            <div class="col-md-3">
              <select type="text" id="sel-order-stastus" class="form-control">
                <option value="all">ALL</option>
                <option value="open">Open</option>
                <option value="confirmed">Confirmed</option>
                <option value="cancel">cancel</option>
              </select>
            </div>
            <div class="col-md-2">
              <label>Pizza Type</label>
            </div>
            <div class="col-md-3">
              <select type="text" id="sel-pizza-type" class="form-control" >
                <option value="all">ALL</option>
                <option value="hawaii">Hawaii</option>
                <option value="bacon">Bacon</option>
                <option value="seafood">Seafood</option>
              </select>
            </div>
            <div class="col-md-2">
              <button class="btn btn-primary" id="btn-filter-order">Lọc dữ liệu</button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="container mt-5">
      <div class="text-center">
        <table id="table-order-data" class="table table-striped table-light table-bordered">
          <thead class="thead-dark">
            <tr>
              <th scope="col">Order ID</th>
              <th scope="col">Kích cỡ combo</th>
              <th scope="col">Loại pizza</th>
              <th scope="col">Nước uống</th>
              <th scope="col">Thành tiền</th>
              <th scope="col">Họ và tên</th>
              <th scope="col">Số điện thoại</th>
              <th scope="col">Trạng thái</th>
              <th scope="col">Chi tiết</th>
            </tr>
          </thead>
          <tbody>
          </tbody>
        </table>
      </div>
    </div>
  </div>

</body>

<script>
  const gBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";
  // hằng số số thứ tự các cột
  var gNameCol = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai",
    "Chi tiết"
  ];
  const gCOLUMN_ORDERID = 0;
  const gCOLUMN_KICH_CO = 1;
  const gCOLUMN_LOAI = 2;
  const gCOLUMN_NUOC_UONG = 3;
  const gCOLUMN_THANH_TIEN = 4;
  const gCOLUMN_FULLNAME = 5;
  const gCOLUMN_PHONE = 6;
  const gCOLUMN_STATUS = 7;
  const gCOLUMN_CHI_TIET = 8;
  var gDataOrder;
  var gTableData = $('#table-order-data').DataTable({
    columns: [{
        data: gNameCol[gCOLUMN_ORDERID]
      },
      {
        data: gNameCol[gCOLUMN_KICH_CO]
      },
      {
        data: gNameCol[gCOLUMN_LOAI]
      },
      {
        data: gNameCol[gCOLUMN_NUOC_UONG]
      },
      {
        data: gNameCol[gCOLUMN_THANH_TIEN]
      },
      {
        data: gNameCol[gCOLUMN_FULLNAME]
      },
      {
        data: gNameCol[gCOLUMN_PHONE]
      },
      {
        data: gNameCol[gCOLUMN_STATUS]
      },
      {
        data: gNameCol[gCOLUMN_CHI_TIET]
      },
    ],
    columnDefs: [{
      targets: gCOLUMN_CHI_TIET, //cột Action
      className: "text-center",
      defaultContent: `
            <button class="btn btn-primary btn-detail"> Chi tiết</button>`
    }, ]
  });

  onPageLoading();

  function onPageLoading() {
    "use strict";
    $.ajax({
      url: gBaseUrl,
      type: "GET",
      data: 'json',
      success: function (res) {
        gDataOrder = res;
        console.log(gDataOrder);
        loadDataToTable(res);
      }
    })
  }
  // btn detail

  $('#table-order-data').on('click', '.btn-detail', function () {
    onBtnDetailButtonClick(this);
  })
  $("#btn-filter-order").on("click", function () {
    onBtnFilterOrderClick();
  })

  function onBtnFilterOrderClick() {
    var vFilterObj = {
      trangThai: '',
      loaiPizza: '',
    }
    console.log(gDataOrder);
    getFilterData(vFilterObj);
    var vDataFilter = gDataOrder.filter(function(paramOrder, index){
      return (vFilterObj.trangThai === 'all' || vFilterObj.trangThai.toUpperCase() === paramOrder.trangThai.toUpperCase())
      && (vFilterObj.loaiPizza === 'all' || vFilterObj.loaiPizza.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
    });
    loadDataToTable(vDataFilter);
  }

  function getFilterData(paramFilterObj) {
    paramFilterObj.trangThai = $("#sel-order-stastus").val().trim();
    paramFilterObj.loaiPizza = $("#sel-pizza-type").val().trim();
  }

  //Hàm xứ lý load dữ liệu lên table
  function loadDataToTable(paramResponseObject) {
    "use strict";
    console.log(paramResponseObject);
    gTableData.clear();
    gTableData.rows.add(paramResponseObject);
    gTableData.draw();

  }

  function onBtnDetailButtonClick(paramBtnDetail) {
    var vRowClicked = $(paramBtnDetail).closest('tr');
    var vDataRow = gTableData.row(vRowClicked).data();
    var vOrderId = vDataRow.orderId;
    console.log(vOrderId);
    window.location.href = "OrderDetail.html" + "?orderId=" + vOrderId;
    return window.location.href;
  }
</script>

</html>